/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util.patterns;

import com.jiuqi.util.patterns.ConstPattern;
import com.jiuqi.util.patterns.IPattern;
import com.jiuqi.util.patterns.ITranslator;
import com.jiuqi.util.patterns.PatternException;
import com.jiuqi.util.patterns.VariablePattern;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

class PlaceholderPattern
implements IPattern {
    private List items = new ArrayList();
    private String expression;
    private boolean isVariable;

    public String toString() {
        StringBuffer buffer = new StringBuffer();
        if (this.isVariable) {
            buffer.append("${");
        }
        int i = 0;
        while (i < this.size()) {
            buffer.append(this.get(i).toString());
            ++i;
        }
        if (this.isVariable) {
            buffer.append("}");
        }
        return buffer.toString();
    }

    public boolean isVariable() {
        return this.isVariable;
    }

    public void setIsVariable(boolean value) {
        this.isVariable = value;
    }

    public void parse(String expression) throws PatternException {
        this.clear();
        this.expression = expression;
        if (expression == null) {
            return;
        }
        int cur = 0;
        int start = 0;
        int stackSize = 0;
        boolean startVar = false;
        while (cur < expression.length()) {
            switch (this.charOf(cur)) {
                case '$': {
                    if (this.charOf(cur + 1) == '{') {
                        if (startVar) {
                            ++stackSize;
                        } else {
                            this.addConst(start, cur);
                            start = cur;
                            startVar = true;
                            stackSize = 0;
                        }
                        cur += 2;
                        break;
                    }
                    ++cur;
                    break;
                }
                case '}': {
                    if (startVar) {
                        if (stackSize == 0) {
                            this.addVariable(start + 2, cur);
                            startVar = false;
                            start = cur + 1;
                        } else {
                            --stackSize;
                        }
                    }
                    ++cur;
                    break;
                }
                default: {
                    ++cur;
                }
            }
        }
        if (cur == expression.length() && cur > start) {
            this.addConst(start, cur);
        }
    }

    private char charOf(int index) {
        return index < 0 || index >= this.expression.length() ? (char)'\u0000' : this.expression.charAt(index);
    }

    private void addConst(int start, int cur) {
        if (start >= cur) {
            return;
        }
        String s = this.expression.substring(start, cur);
        ConstPattern p = new ConstPattern(s);
        this.add(p);
    }

    private void addVariable(int start, int cur) throws PatternException {
        if (start >= cur) {
            return;
        }
        String s = this.expression.substring(start, cur);
        int p1 = s.indexOf("${");
        int p2 = s.lastIndexOf(125);
        if (p1 >= 0 && p1 < p2) {
            PlaceholderPattern p = new PlaceholderPattern();
            p.parse(s);
            p.setIsVariable(true);
            this.add(p);
        } else {
            VariablePattern p = new VariablePattern();
            p.parse(s);
            this.add(p);
        }
    }

    public void add(IPattern pattern) {
        this.items.add(pattern);
    }

    public void add(int index, IPattern pattern) {
        this.items.add(index, pattern);
    }

    public void clear() {
        this.items.clear();
        this.expression = null;
        this.isVariable = false;
    }

    public IPattern get(int index) {
        return (IPattern)this.items.get(index);
    }

    public String getExpression() {
        return this.toString();
    }

    public int getLength() {
        return 0;
    }

    public int getType() {
        return 1;
    }

    public int indexOf(IPattern pattern) {
        return this.items.indexOf(pattern);
    }

    public void remove(int index) {
        this.items.remove(index);
    }

    public void setExpression(String value) {
        try {
            this.parse(value);
        }
        catch (PatternException patternException) {
            this.clear();
        }
    }

    public void setLength(int value) {
    }

    public int size() {
        return this.items.size();
    }

    public int match(String s, int start, Map values) {
        if (this.isVariable) {
            return -1;
        }
        int cur = 0;
        int next = start;
        while (cur < this.size()) {
            switch (this.get(cur).getType()) {
                case 0: {
                    next = this.get(cur).match(s, start, values);
                    if (next != -1) break;
                    return -1;
                }
                case 1: {
                    if (this.get(cur).getLength() > 0) {
                        next = this.get(cur).match(s, start, values);
                        if (next == -1) {
                            return -1;
                        }
                        String value = s.substring(start, next);
                        values.put(this.get(cur).getExpression(), value);
                        break;
                    }
                    if (cur >= this.size() - 1) {
                        String value = s.substring(start);
                        values.put(this.get(cur).getExpression(), value);
                        next = s.length();
                        break;
                    }
                    if (this.get(cur + 1).getType() == 0) {
                        next = s.indexOf(this.get(cur + 1).getExpression(), start + 1);
                        if (next == -1) {
                            return -1;
                        }
                        String value = s.substring(start, next);
                        values.put(this.get(cur).getExpression(), value);
                        break;
                    }
                    int backLen = this.statNextLength(cur);
                    if (backLen == -1 || start >= s.length() - backLen) {
                        return -1;
                    }
                    next = s.length() - backLen;
                    String value = s.substring(start, next);
                    values.put(this.get(cur).getExpression(), value);
                }
            }
            start = next;
            ++cur;
        }
        return start;
    }

    private int statNextLength(int cur) {
        int len = 0;
        int i = cur + 1;
        while (i < this.size()) {
            switch (this.get(i).getType()) {
                case 0: {
                    len += this.get(i).getLength();
                    break;
                }
                case 1: {
                    if (this.get(i).getLength() > 0) {
                        len += this.get(i).getLength();
                        break;
                    }
                    return -1;
                }
                default: {
                    return -1;
                }
            }
            ++i;
        }
        return len;
    }

    public String replace(ITranslator translator) {
        StringBuffer buffer = new StringBuffer();
        int i = 0;
        while (i < this.size()) {
            buffer.append(this.get(i).replace(translator));
            ++i;
        }
        if (this.isVariable) {
            String[] ret = translator.translate(buffer.toString(), 0);
            if (ret == null) {
                return buffer.toString();
            }
            return ret.length == 0 ? "" : ret[0];
        }
        return buffer.toString();
    }
}

